<?php
$parser = xml_parser_create();
xml_set_element_handler($parser, "openTag", "closeTag");

// A string of 1Mb
$contentBytes = 1024 * 1024;
$attrContentChunk = str_repeat('A', $contentBytes);

// Total number of chunks to create the attribute value
$numChunks = 10;
$chunkSize = strlen($attrContentChunk) / 1024;
echo sprintf("\nCreating %d chunks (of %d K each) to create a single tag attribute value totalling %d K\n\n", $numChunks, $chunkSize, $chunkSize * $numChunks);

$processedBytes = 0;
$buf = '<root><child some="';
for($i=1; $i<=$numChunks; $i++) {
    $buf .= $attrContentChunk;
    $len = strlen($buf);

    if ($i === $numChunks) {
        $buf .= '"></child></root>';
    }

    $processedBytes += strlen($buf);;
    if (!xml_parse($parser, $buf, $i === $numChunks)) {
        echo sprintf("\nERROR WHILE PROCESSING UNTIL BYTE $processedBytes: %s\n\n", xml_error_string(xml_get_error_code($parser)));
        exit(1);
    }

    echo sprintf("Processed chunk #$i: %d bytes\n", $processedBytes);

    $buf = '';
}

echo "OK!\n";
exit;

function openTag($p, $tag) {
  echo "Opened tag $tag\n";
}

function closeTag($p, $tag) {
  echo "Closed tag $tag\n";
}

